//+------------------------------------------------------------------
//| Copyright Lots of other coders and a little bit of my own creation all integrated by me.  2011
//| Thanks to Matus German for some of the code and other great coders I cant remember for some code lines and ideas,                                 
//+------------------------------------------------------------------
extern double TP = 1.66;
extern double SL=1.87;
extern double TrailingStop= 1.57;
extern double ATRts=42;
extern bool UseHourTrade = True;
extern int FromHourTrade = 8;// GMT-1 time 
extern int ToHourTrade = 17;// GMT-1 time 
extern double Lots = 1;        // max lots per position
extern double maxContracts = 1;     // max open positions 2 is optimal for smoother equity

extern double EMAS=11;              // EMA to determine trend
extern double EMAL=29;              // EMA to determine trend

double signal, EmaShort, EmaLong, EmaShortP;
bool BuyValue, SellValue;
double h_1, h_2, h_3,h_4,l_1,l_2,l_3,l_4,o_1,o_2,o_3,c_1,c_2,c_3;

double Ilo;
int cnt, ticket, total;

int init()
{
   Comment("Moving Average and Three Crows");
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int start()
   
 { 
//Define trading hours
 if(UseHourTrade)
   {
   if((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
      Comment("Trading Hours");
   else
     {
      Comment("Non-trading Hours");
      return(0);
     }
   }
   
// discover EMA for the trend recognition 
   EmaShort=iMA(NULL,0,EMAS,0,MODE_EMA,PRICE_MEDIAN,0);
   EmaLong=iMA(NULL,0,EMAL,0,MODE_EMA,PRICE_MEDIAN,0);
   EmaShortP=iMA(NULL,0,EMAS,0,MODE_EMA,PRICE_MEDIAN,1);

// discover swing in formation 
        h_1=High[1];
        h_2=High[2];
        h_3=High[3];
        h_4=High[4];
       l_1=Low[1];
       l_2=Low[2];
       l_3=Low[3];
       l_4=Low[4];
       o_1=Open[1];
       o_2=Open[2];
       o_3=Open[3];
       c_1=Close[1];
       c_2=Close[2];
       c_3=Close[3];

// reset signal at start
   BuyValue=0;
   SellValue=0;
 
// Buy Signal
   if (EmaShort> EmaLong && h_1<h_2 &&  h_2<h_3  && l_1<l_2 &&  l_2<l_3 &&  c_1<o_1 && c_2<o_2 && c_3<o_3) 
   {     
      BuyValue=1; 
   }

// Sell Signal
   if (EmaShort < EmaLong && l_1>l_2 &&  l_2>l_3 && h_1>h_2 &&  h_2>h_3 &&  c_1>o_1 && c_2>o_2 && c_3>o_3) 
   {     
      SellValue=1;
   } 
// exit on trailing stop   
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be modified
            
            if(Bid-OrderOpenPrice()>iATR(Symbol(),0,ATRts,0))
            {
                 OrderModify(OrderTicket(),OrderLots(),Bid-iATR(Symbol(),0,ATRts,0)*TrailingStop,OrderTakeProfit(),Violet); // close position
                 return(0);
            }
         }
         else // go to short position
         {
            // should it be modified
            
               if(OrderOpenPrice()-Ask>iATR(Symbol(),0,ATRts,0))
             {
                  OrderModify(OrderTicket(),OrderLots(),Ask+iATR(Symbol(),0,ATRts,0)*TrailingStop,OrderTakeProfit(),Violet); // close position
                  return(0);
             }
         }
      }
   }


   total=OrdersTotal();

// enter market conditions   
   if(total<maxContracts) 
   {
// check for long position (BUY) possibility
      if(BuyValue==1)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3, Low[1]-SL*iATR(Symbol(),0,100,0),High[3]+TP*iATR(Symbol(),0,100,0),NULL,16384,0,Green);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         }
         else Print("Error opening BUY order : ",GetLastError()); 

      }
      
// check for short position (SELL) possibility
      if(SellValue==1)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3, High[1]+iATR(Symbol(),0,100,0)*SL,Low[3]-TP*iATR(Symbol(),0,100,0),NULL,16384,0,Red);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
         }
         else Print("Error opening SELL order : ",GetLastError()); 
      }
   }     
   return(0); // exit
}

